﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[System.Serializable]
public class ExplosionParams{
	public float force,radius; 
}

public class EnemyController : MonoBehaviour {

	public int maxHit;
	public float destroylatency;
	public ExplosionParams explosion;
	public float multiplier;
	private Rigidbody _rigidbody;
	private int hitcounter;


	void Start(){
		_rigidbody = GetComponent <Rigidbody>();
		hitcounter = 0;
	}

	void OnMouseOver(){
		if (Input.GetButtonDown ("Fire1")) {
			hit ();
			//Debug.Log (name);
		}
	}
		
	public void hit(){
		hitcounter++;
		if(hitcounter==maxHit)
		{
//			_rigidbody.AddExplosionForce (explosion.force,transform.position,explosion.radius);
			var rigidbodies = new List<Rigidbody>();
			var cols = Physics.OverlapSphere (transform.position, explosion.radius);
			//Add to list all attached rigidbodies on overlapspheres
			foreach (var col in cols){
				if(col.attachedRigidbody!=null && !rigidbodies.Contains (col.attachedRigidbody)){
					rigidbodies.Add (col.attachedRigidbody);
					//print ("add");
				}
			}

			//add explosion for all rigidbodies in List
			foreach(var rb in rigidbodies){
				if(rb.gameObject.layer == 8)
					rb.AddExplosionForce (explosion.force, transform.position, explosion.radius, multiplier);
			}

			Destroy (gameObject);
		}
	}
		
}
