﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MouseMovement : MonoBehaviour {

	public Rigidbody m_Rigidbody;

	public float m_MovePower;

	public float speedLimit;

	public Vector3 movingDirection;

	public float impulseTimer;

	public float impulseTimerLimit;

	private Vector3 randomImpulseDirection;

	public float impulseForce;

	private float startAt;
	private float startCounter;

	void Start () 
	{
		m_Rigidbody = transform.GetComponent<Rigidbody>();
		impulseTimerLimit = Random.Range(2f,6f);
		startAt = 5;
	}
	
	void FixedUpdate () 
	{
		startCounter += Time.deltaTime;

		if(startCounter > startAt)
		{
			RandomImpulseOverTime();

			m_Rigidbody.AddForce(movingDirection * m_MovePower, ForceMode.Force);

			if(m_Rigidbody.velocity.magnitude > speedLimit)
			{
				Vector3 controlledVelocity = m_Rigidbody.velocity.normalized * speedLimit;
				m_Rigidbody.velocity = controlledVelocity;
			}
		}
	
	}

	public void Impulse(Vector3 direction)
	{
		m_Rigidbody.AddForce(direction,ForceMode.Impulse);
	}

	public void RandomImpulseOverTime()
	{
		impulseTimer += Time.deltaTime;

		if(impulseTimer > impulseTimerLimit)
		{
			randomImpulseDirection= new Vector3(Random.Range(-1f,1f),Random.Range(-1f,1f),Random.Range(0f,1f)) * impulseForce;

			Impulse(randomImpulseDirection);

			impulseTimer = 0;
		}
	}


}
